/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.35 from the
 * contents of Journald.xs. Do not edit this file, edit Journald.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Log/Journald.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <sys/uio.h>

/* We determine our location from the Perl code instead. */
#define SD_JOURNAL_SUPPRESS_LOCATION
#include <systemd/sd-journal.h>

/* Extra fields to be added at the end of each log vector. */
enum {
	CODE_FILE,
	CODE_LINE,
	EXTRA_CNT
};

/* Fill in an iovec entry with a formatted string. */
#define IOVEC_FMT(vec, ...) do {					\
	(vec).iov_len = asprintf ((char **)&(vec).iov_base, __VA_ARGS__); \
	if ((vec).iov_len == -1)					\
		(vec).iov_base = NULL;					\
} while(0)

/* Allocate iovec for given number of fields, automatically filling extra
 * entries at the end. */
static struct iovec *
alloc_iovec (items)
	const int items;
{
	struct iovec *logv;

	logv = malloc(sizeof (struct iovec) * (items + EXTRA_CNT));
	if (logv == NULL)
		return NULL;

	IOVEC_FMT(logv[items + CODE_FILE], "CODE_FILE=%s",
		OutCopFILE(PL_curcop));
	IOVEC_FMT(logv[items + CODE_LINE], "CODE_LINE=%d",
		CopLINE(PL_curcop));

	return logv;
}

/* Send the vector to the journal and deallocate the extra entries we've
 * allcoated in alloc_iovec(). Handle errors in the manner more typical to
 * Perl (return -1 & set errno as opposed to returning -errno. */
static int
submit_iovec (logv, items)
	struct iovec *logv;
	const int items;
{
	int err;

	err = sd_journal_sendv(logv, items + EXTRA_CNT);
	free(logv[items + CODE_FILE].iov_base);
	free(logv[items + CODE_LINE].iov_base);
	if (err) {
		errno = -err;
		return -1;
	}

	return 0;
}

#line 76 "lib/Log/Journald.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 220 "lib/Log/Journald.c"

XS_EUPXS(XS_Log__Journald_journal_log); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Log__Journald_journal_log)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "prio, msg");
    {
	int	prio = (int)SvIV(ST(0))
;
	const char *	msg = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 74 "lib/Log/Journald.xs"
		struct iovec *logv;

		logv = alloc_iovec(2);
		if (logv == NULL) {
			errno = ENOMEM;
			XSRETURN_UNDEF;
		}

		IOVEC_FMT(logv[0], "PRIORITY=%d", prio);
		IOVEC_FMT(logv[1], "MESSAGE=%s", msg);

		if (submit_iovec(logv, items) == 0) {
			RETVAL = 1;
		} else {
			RETVAL = 0;
		}
		free(logv[0].iov_base);
		free(logv[1].iov_base);
		free(logv);
		if (RETVAL == 0)
			XSRETURN_UNDEF;
#line 257 "lib/Log/Journald.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Log__Journald_send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Log__Journald_send)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "key, value, ...");
    {
	int	RETVAL;
	dXSTARG;
#line 102 "lib/Log/Journald.xs"
		int i;
		struct iovec *logv;

		if (items % 2)
			croak("odd arguments to Log::Journald::send");
		logv = alloc_iovec(items / 2);
		if (logv == NULL) {
			errno = ENOMEM;
			XSRETURN_UNDEF;
		}

		for (i = 0; i < items; i += 2) {
			STRLEN key_len, val_len, len;
			const char *key, *val;
			char *msg;

			key = SvPV(ST(i), key_len);
			val = SvPV(ST(i+1), val_len);
			len = key_len + 1 + val_len;
			logv[i / 2].iov_base = msg = malloc(len);
			if (msg == NULL) {
				logv[i / 2].iov_len = -1;
			} else {
				memcpy(msg, key, key_len);
				msg += key_len;
				*msg++ = '=';
				memcpy(msg, val, val_len);
				logv[i / 2].iov_len = len;
			}
		}

		if (submit_iovec(logv, items / 2) == 0) {
			RETVAL = 1;
		} else {
			RETVAL = 0;
		}
		for (i = 0; i < items; i += 2)
			free (logv[i / 2].iov_base);
		free(logv);
		if (RETVAL == 0)
			XSRETURN_UNDEF;
#line 315 "lib/Log/Journald.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Log__Journald_sendv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Log__Journald_sendv)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "arg, ...");
    {
	int	RETVAL;
	dXSTARG;
#line 150 "lib/Log/Journald.xs"
		int i;
		struct iovec *logv;

		logv = alloc_iovec(items);
		if (logv == NULL) {
			errno = ENOMEM;
			XSRETURN_UNDEF;
		}

		for (i = 0; i < items; i++) {
			logv[i].iov_base = SvPV(ST(i), logv[i].iov_len);
		}

		if (submit_iovec(logv, items) == 0) {
			RETVAL = 1;
		} else {
			RETVAL = 0;
		}
		free(logv);
		if (RETVAL == 0)
			XSRETURN_UNDEF;
#line 353 "lib/Log/Journald.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Log__Journald); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Log__Journald)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Log::Journald::journal_log", XS_Log__Journald_journal_log);
        newXS_deffile("Log::Journald::send", XS_Log__Journald_send);
        newXS_deffile("Log::Journald::sendv", XS_Log__Journald_sendv);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

